/*
 * Copyright 2013-2018 Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You may not use this file except in compliance with
 * the License. A copy of the License is located at
 * 
 * http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
 * CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions
 * and limitations under the License.
 */
package com.amazonaws.services.ec2.model.transform;

import javax.annotation.Generated;

import com.amazonaws.SdkClientException;
import com.amazonaws.Request;
import com.amazonaws.DefaultRequest;
import com.amazonaws.http.HttpMethodName;
import com.amazonaws.services.ec2.model.*;
import com.amazonaws.transform.Marshaller;
import com.amazonaws.util.StringUtils;

/**
 * ModifyVpcEndpointConnectionNotificationRequest Marshaller
 */

@Generated("com.amazonaws:aws-java-sdk-code-generator")
public class ModifyVpcEndpointConnectionNotificationRequestMarshaller implements
        Marshaller<Request<ModifyVpcEndpointConnectionNotificationRequest>, ModifyVpcEndpointConnectionNotificationRequest> {

    public Request<ModifyVpcEndpointConnectionNotificationRequest> marshall(
            ModifyVpcEndpointConnectionNotificationRequest modifyVpcEndpointConnectionNotificationRequest) {

        if (modifyVpcEndpointConnectionNotificationRequest == null) {
            throw new SdkClientException("Invalid argument passed to marshall(...)");
        }

        Request<ModifyVpcEndpointConnectionNotificationRequest> request = new DefaultRequest<ModifyVpcEndpointConnectionNotificationRequest>(
                modifyVpcEndpointConnectionNotificationRequest, "AmazonEC2");
        request.addParameter("Action", "ModifyVpcEndpointConnectionNotification");
        request.addParameter("Version", "2016-11-15");
        request.setHttpMethod(HttpMethodName.POST);

        if (modifyVpcEndpointConnectionNotificationRequest.getConnectionNotificationId() != null) {
            request.addParameter("ConnectionNotificationId",
                    StringUtils.fromString(modifyVpcEndpointConnectionNotificationRequest.getConnectionNotificationId()));
        }

        if (modifyVpcEndpointConnectionNotificationRequest.getConnectionNotificationArn() != null) {
            request.addParameter("ConnectionNotificationArn",
                    StringUtils.fromString(modifyVpcEndpointConnectionNotificationRequest.getConnectionNotificationArn()));
        }

        com.amazonaws.internal.SdkInternalList<String> modifyVpcEndpointConnectionNotificationRequestConnectionEventsList = (com.amazonaws.internal.SdkInternalList<String>) modifyVpcEndpointConnectionNotificationRequest
                .getConnectionEvents();
        if (!modifyVpcEndpointConnectionNotificationRequestConnectionEventsList.isEmpty()
                || !modifyVpcEndpointConnectionNotificationRequestConnectionEventsList.isAutoConstruct()) {
            int connectionEventsListIndex = 1;

            for (String modifyVpcEndpointConnectionNotificationRequestConnectionEventsListValue : modifyVpcEndpointConnectionNotificationRequestConnectionEventsList) {
                if (modifyVpcEndpointConnectionNotificationRequestConnectionEventsListValue != null) {
                    request.addParameter("ConnectionEvents." + connectionEventsListIndex,
                            StringUtils.fromString(modifyVpcEndpointConnectionNotificationRequestConnectionEventsListValue));
                }
                connectionEventsListIndex++;
            }
        }

        return request;
    }

}
