/*
 * Copyright 2013-2018 Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You may not use this file except in compliance with
 * the License. A copy of the License is located at
 * 
 * http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
 * CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions
 * and limitations under the License.
 */
package com.amazonaws.services.ec2.model.transform;

import javax.xml.stream.events.XMLEvent;
import javax.annotation.Generated;

import com.amazonaws.services.ec2.model.*;
import com.amazonaws.transform.Unmarshaller;

import com.amazonaws.transform.StaxUnmarshallerContext;
import com.amazonaws.transform.SimpleTypeStaxUnmarshallers.*;

/**
 * SnapshotDiskContainer StAX Unmarshaller
 */

@Generated("com.amazonaws:aws-java-sdk-code-generator")
public class SnapshotDiskContainerStaxUnmarshaller implements Unmarshaller<SnapshotDiskContainer, StaxUnmarshallerContext> {

    public SnapshotDiskContainer unmarshall(StaxUnmarshallerContext context) throws Exception {
        SnapshotDiskContainer snapshotDiskContainer = new SnapshotDiskContainer();
        int originalDepth = context.getCurrentDepth();
        int targetDepth = originalDepth + 1;

        if (context.isStartOfDocument())
            targetDepth += 1;

        while (true) {
            XMLEvent xmlEvent = context.nextEvent();
            if (xmlEvent.isEndDocument())
                return snapshotDiskContainer;

            if (xmlEvent.isAttribute() || xmlEvent.isStartElement()) {

                if (context.testExpression("Description", targetDepth)) {
                    snapshotDiskContainer.setDescription(StringStaxUnmarshaller.getInstance().unmarshall(context));
                    continue;
                }

                if (context.testExpression("Format", targetDepth)) {
                    snapshotDiskContainer.setFormat(StringStaxUnmarshaller.getInstance().unmarshall(context));
                    continue;
                }

                if (context.testExpression("Url", targetDepth)) {
                    snapshotDiskContainer.setUrl(StringStaxUnmarshaller.getInstance().unmarshall(context));
                    continue;
                }

                if (context.testExpression("UserBucket", targetDepth)) {
                    snapshotDiskContainer.setUserBucket(UserBucketStaxUnmarshaller.getInstance().unmarshall(context));
                    continue;
                }
            } else if (xmlEvent.isEndElement()) {
                if (context.getCurrentDepth() < originalDepth) {
                    return snapshotDiskContainer;
                }
            }
        }
    }

    private static SnapshotDiskContainerStaxUnmarshaller instance;

    public static SnapshotDiskContainerStaxUnmarshaller getInstance() {
        if (instance == null)
            instance = new SnapshotDiskContainerStaxUnmarshaller();
        return instance;
    }
}
